#include <iostream>
class CMediaBuffer
{
private	:
	char *dataBuffer;
	
	int tsinc_msec;	
	int buffer_size;
	
public :
	int bufferCount;
	
	CMediaBuffer *ObjNextBuffer;
	CMediaBuffer *ObjPrevBuffer;	
	CMediaBuffer(int x)
	{
		bufferCount = x;
		dataBuffer = NULL;
		ObjNextBuffer = NULL;
		ObjPrevBuffer = NULL;
	};
	char *getBuffer(int *size,int *timestampInc)
	{
		*size = buffer_size; 
		
		if(timestampInc != NULL)
			*timestampInc = tsinc_msec; 
		return dataBuffer; 
	};

	void freeBuffer()
	{
		free(dataBuffer);
		dataBuffer = NULL;
	};	
	int setBuffer(int size, char *buf, int ts_msec)
	{
		dataBuffer = (char *)malloc(size * sizeof(char));
		if(dataBuffer == NULL)
		{
			cout << "Cannot allocate Memory " << endl;
			return -1;		
		}
		memcpy(dataBuffer,buf, size);
		buffer_size = size;
		tsinc_msec = ts_msec;
		return 0;

	};
	void setNextBuffer(CMediaBuffer *nxtbuf)
	{
		ObjNextBuffer = nxtbuf;	
	};	
	void setPrevBuffer(CMediaBuffer *prevbuf)
	{
		ObjPrevBuffer = prevbuf;
		
	};
};

