#ifndef INCLUDE_INTERFACES_H
#define INCLUDE_INTERFACES_H

#include "common_defines.h"
#include <iostream>
using namespace std;
class IVideoCapture
{
public :
	
	virtual void getVideoFormat() = 0;
	virtual void setVideoFormat() = 0;
	virtual void getVideoDeviceProp() = 0;
	virtual void Process_Raw_Video(int buffers_ready,int PixFormat, int bufsize,int width, int height, unsigned char *data, int tsinc_usec) = 0;
	
	
	static void print_fps( )
	{

		static struct timeval next,current;
		static int count = 0;
		if( count == 0 )
		{
			gettimeofday(&next, NULL);
			next.tv_sec += 1;
		}

		count++;
	
		gettimeofday(&current, NULL);

		if( timercmp( &next, &current, <= ) )
		{
			printf( "FPS: %d\n", count );
			count = 0;
		}


		static struct timeval oldframe,currentframe;
		static int counter = 0;
		if(counter == 0)
		{
			gettimeofday(&oldframe, NULL);
		}
		counter++;
		gettimeofday(&currentframe, NULL);
		
	//	int p = (currentframe.tv_sec *1000 + currentframe.tv_usec) - (oldframe.tv_sec *1000 + oldframe.tv_usec);
//		if(p < 200)
//printf("Time diff : %d usecs\n",p );
		oldframe = currentframe;

	}	

};
 
class IVideoEnc
{
	virtual void encode_frame() = 0;
	virtual void convert_img_format() = 0;
};



#endif


